diff --git a/doc/guides/cryptodevs/dpaa2_sec.rst b/doc/guides/cryptodevs/dpaa2_sec.rst
index 5558ea593e10..fcea48375912 100644
--- a/doc/guides/cryptodevs/dpaa2_sec.rst
+++ b/doc/guides/cryptodevs/dpaa2_sec.rst
@@ -211,7 +211,7 @@ For enabling logs, use the following EAL parameter:
 
 .. code-block:: console
 
-   ./your_crypto_application <EAL args> --log-level=pmd.crypto.dpaa2,<level>
+   ./your_crypto_application <EAL args> --log-level=pmd.crypto.dpaa2:<level>
 
 Using ``crypto.dpaa2`` as log matching criteria, all Crypto PMD logs can be
 enabled which are lower than logging ``level``.
diff --git a/doc/guides/cryptodevs/dpaa_sec.rst b/doc/guides/cryptodevs/dpaa_sec.rst
index 2964e83572eb..caf3d9cab2ac 100644
--- a/doc/guides/cryptodevs/dpaa_sec.rst
+++ b/doc/guides/cryptodevs/dpaa_sec.rst
@@ -154,7 +154,7 @@ For enabling logs, use the following EAL parameter:
 
 .. code-block:: console
 
-   ./your_crypto_application <EAL args> --log-level=pmd.crypto.dpaa,<level>
+   ./your_crypto_application <EAL args> --log-level=pmd.crypto.dpaa:<level>
 
 Using ``pmd.crypto.dpaa`` as log matching criteria, all Crypto PMD logs can be
 enabled which are lower than logging ``level``.
diff --git a/doc/guides/faq/faq.rst b/doc/guides/faq/faq.rst
index c1132fb4162f..f19c1389b6af 100644
--- a/doc/guides/faq/faq.rst
+++ b/doc/guides/faq/faq.rst
@@ -62,19 +62,16 @@ the wrong socket, the application simply will not start.
 On application startup, there is a lot of EAL information printed. Is there any way to reduce this?
 ---------------------------------------------------------------------------------------------------
 
-Yes, the option ``--log-level=`` accepts one of these numbers:
-
-.. code-block:: c
-
-    #define RTE_LOG_EMERG 1U    /* System is unusable. */
-    #define RTE_LOG_ALERT 2U    /* Action must be taken immediately. */
-    #define RTE_LOG_CRIT 3U     /* Critical conditions. */
-    #define RTE_LOG_ERR 4U      /* Error conditions. */
-    #define RTE_LOG_WARNING 5U  /* Warning conditions. */
-    #define RTE_LOG_NOTICE 6U   /* Normal but significant condition. */
-    #define RTE_LOG_INFO 7U     /* Informational. */
-    #define RTE_LOG_DEBUG 8U    /* Debug-level messages. */
-
+Yes, the option ``--log-level=`` accepts either symbolic names (or numbers):
+
+1. emergency
+2. alert
+3. critical
+4. error
+5. warning
+6. notice
+7. info
+8. debug
 
 How can I tune my network application to achieve lower latency?
 ---------------------------------------------------------------
diff --git a/doc/guides/nics/dpaa2.rst b/doc/guides/nics/dpaa2.rst
index 8e38efff4a27..85d26503f325 100644
--- a/doc/guides/nics/dpaa2.rst
+++ b/doc/guides/nics/dpaa2.rst
@@ -547,7 +547,7 @@ For enabling logging for DPAA2 PMD, following log-level prefix can be used:
 
  .. code-block:: console
 
-    <dpdk app> <EAL args> --log-level=bus.fslmc,<level> -- ...
+    <dpdk app> <EAL args> --log-level=bus.fslmc:<level> -- ...
 
 Using ``bus.fslmc`` as log matching criteria, all FSLMC bus logs can be enabled
 which are lower than logging ``level``.
@@ -556,7 +556,7 @@ which are lower than logging ``level``.
 
  .. code-block:: console
 
-    <dpdk app> <EAL args> --log-level=pmd.net.dpaa2,<level> -- ...
+    <dpdk app> <EAL args> --log-level=pmd.net.dpaa2:<level> -- ...
 
 Using ``pmd.dpaa2`` as log matching criteria, all PMD logs can be enabled
 which are lower than logging ``level``.
diff --git a/doc/guides/nics/qede.rst b/doc/guides/nics/qede.rst
index 42dd70db39df..f6fb548155a3 100644
--- a/doc/guides/nics/qede.rst
+++ b/doc/guides/nics/qede.rst
@@ -193,7 +193,7 @@ This section provides instructions to configure SR-IOV with Linux OS.
 
 
 #. Running testpmd
-   (Supply ``--log-level="pmd.net.qede.driver:7`` to view informational messages):
+   (Supply ``--log-level="pmd.net.qede.driver:info`` to view informational messages):
 
    Refer to the document
    :ref:`compiling and testing a PMD for a NIC <pmd_build_and_test>` to run
diff --git a/doc/guides/nics/sfc_efx.rst b/doc/guides/nics/sfc_efx.rst
index abaed67f52b6..07ccafaaf750 100644
--- a/doc/guides/nics/sfc_efx.rst
+++ b/doc/guides/nics/sfc_efx.rst
@@ -356,26 +356,26 @@ Dynamic Logging Parameters
 
 One may leverage EAL option "--log-level" to change default levels
 for the log types supported by the driver. The option is used with
-an argument typically consisting of two parts separated by a comma.
+an argument typically consisting of two parts separated by a colon.
 
-Level value is the last part which takes an integer greater than 0.
-Log type is the former part which may contain a regular expression.
+Level value is the last part which takes a symbolic name (or integer).
+Log type is the former part which may shell match syntax.
 Depending on the choice of the expression, the given log level may
 be used either for some specific log type or for a subset of types.
 
 SFC EFX PMD provides the following log types available for control:
 
-- ``pmd.net.sfc.driver`` (default level is **6** - ``RTE_LOG_NOTICE``)
+- ``pmd.net.sfc.driver`` (default level is **notice**)
 
   Affects driver-wide messages unrelated to any particular devices.
 
-- ``pmd.net.sfc.main`` (default level is **6** - ``RTE_LOG_NOTICE``)
+- ``pmd.net.sfc.main`` (default level is **notice**)
 
   Matches a subset of per-port log types registered during runtime.
   A full name for a particular type may be obtained by appending a
   dot and a PCI device identifier (``XXXX:XX:XX.X``) to the prefix.
 
-- ``pmd.net.sfc.mcdi`` (default level is **6** - ``RTE_LOG_NOTICE``)
+- ``pmd.net.sfc.mcdi`` (default level is **notice**)
 
   Extra logging of the communication with the NIC's management CPU.
   The format of the log is consumed by the Solarflare netlogdecode
diff --git a/doc/guides/nics/tap.rst b/doc/guides/nics/tap.rst
index c97786acaa53..3e038cc5eec1 100644
--- a/doc/guides/nics/tap.rst
+++ b/doc/guides/nics/tap.rst
@@ -166,7 +166,7 @@ Run pktgen from the pktgen directory in a terminal with a commandline like the
 following::
 
     sudo ./app/app/x86_64-native-linuxapp-gcc/app/pktgen -l 1-5 -n 4        \
-     --proc-type auto --log-level 8 --socket-mem 512,512 --file-prefix pg   \
+     --proc-type auto --log-level debug --socket-mem 512,512 --file-prefix pg   \
      --vdev=net_tap0 --vdev=net_tap1 -b 05:00.0 -b 05:00.1                  \
      -b 04:00.0 -b 04:00.1 -b 04:00.2 -b 04:00.3                            \
      -b 81:00.0 -b 81:00.1 -b 81:00.2 -b 81:00.3                            \